﻿// GrepToIndex.jsx
// An InDesign JavaScript

main();

function main() {

	var myAnswer = myDialogBox();
	if (!myAnswer || !myAnswer[0]) {
		return;
	}

	var myIndexCount = IndexGrep(myAnswer);
	if (myIndexCount) {
		alert("총 " + myIndexCount + "건의 색인이 생성되었습니다.");
	}
	else {
		alert("색인이 생성되지 않았습니다.");
	}

};

function myDialogBox() {
	var doc = app.activeDocument;
	var myEntryWidth = 300;

	var myDialog = app.dialogs.add({ name: "Grep to Index" });

	with (myDialog.dialogColumns.add()) {
		with (dialogRows.add()) {
			with (dialogColumns.add()) {
				staticTexts.add({ staticLabel: "색인할 텍스트 GREP:" });
			}
			with (dialogColumns.add()) {
				var myGrepToFindField = textEditboxes.add({ minWidth: myEntryWidth });
				var myIncludesFootnoteCheckbox = checkboxControls.add({ staticLabel: "각주 포함", checkedState: true });
				var myResetsIndexCheckbox = checkboxControls.add({ staticLabel: "기존 색인 삭제", checkedState: false });
			}
		}
	}

	var myResult = myDialog.show();
	if (myResult) {
		var myAnswer = [myGrepToFindField.editContents,
						myIncludesFootnoteCheckbox.checkedState,
						myResetsIndexCheckbox.checkedState];
		myDialog.destroy();
		return myAnswer;
	}
	else {
		myDialog.destroy();
		return null;
	}

};

function IndexGrep(myAnswer) {

	var doc = app.activeDocument;
	var myIndexCount = 0;

	var myGrepToFind = myAnswer[0];
	var myIncludesFootnote = myAnswer[1];
	var myResetsIndex = myAnswer[2];

	app.findGrepPreferences = null;
	app.findChangeGrepOptions.properties = {
		// includeLockedLayersForFind: false,
		// includeLockedStoriesForFind: false,
		// includeHiddenLayers: true,
		// includeMasterPages: false,
		includeFootnotes: myIncludesFootnote
	};

	if (doc.indexes.length == 0) {
		doc.indexes.add();
	}
	if (myResetsIndex) {
		doc.indexes[0].topics.everyItem().remove();
	}
	
	app.findGrepPreferences.findWhat = myGrepToFind;

	var found = doc.findGrep();
	for (var i=0; i < found.length; i++) {
		var myTopic = doc.indexes[0].topics.add(found[i].contents);
		myTopic.pageReferences.add(found[i], PageReferenceType.CURRENT_PAGE);
		myIndexCount ++;
	}

	return myIndexCount;
	
}